<template>
	<v-row class="search-box">
		<v-col v-if="label" :cols="labelCols">
			<!-- <label for="" class="search-box-label"> -->
			<label for="" class="search-box-label">
				<v-icon x-small color="primary" class="mr-1">mdi-record-circle</v-icon>
				{{ label }}
			</label>
		</v-col>
		<v-col :cols="label ? textCols : ''">
			<!-- :value="textfield" -->
			<v-text-field
				readonly
				v-model="selectValue"
				append-icon="mdi-magnify"
				class="v-input__custom"
				@click="dialog = !dialog"
				:hide-details="true"
				outlined
			></v-text-field>
		</v-col>

		<!-- <v-row justify="center"> -->
		<v-dialog v-model="dialog" scrollable width="540px">
			<!-- <template v-slot:activator="{ on, attrs }">
        <v-btn color="primary" dark v-bind="attrs" v-on="on">공정/설비</v-btn>
      </template> -->
			<v-card style="height: 100%">
				<v-card-title>
					<!-- <span v-if="!label" class="text-h5">
            공정/설비
          </span> -->
					<span v-if="label" class="custom-title-4">
						검침개소
					</span>
				</v-card-title>
				<v-card-actions>
					<!-- <v-text-field label="위치정보 선택"></v-text-field> -->
					<v-col v-if="label" cols="3">
						<label for="" class="search-box-label">
							위치정보 선택
						</label>
					</v-col>
					<v-col :cols="label ? 6 : ''">
						<!-- :value="textfield" -->
						<v-text-field
							append-icon="mdi-magnify"
							class="v-input__custom"
						></v-text-field>
					</v-col>

					<v-spacer></v-spacer>
					<v-btn color="primary" dark @click="btnTreeExpand()">{{
						treeExpand
					}}</v-btn>
					<!-- <v-btn color="primary" dark>펼치기</v-btn> -->
					<!-- <v-btn color="primary" dark>접기</v-btn> -->
					<v-btn color="primary" dark>초기화</v-btn>
					<!-- as-is 롤 봐도 초기화가 하는 기능을 모르겠음.. -->
				</v-card-actions>
				<v-divider></v-divider>
				<v-card-text>
					<div ref="treeGridParent" style="height: 500px">
						<component
							:ref="'treeGrid' + parentPrgmId"
							:is="loadGrid && dialog ? 'Grid' : null"
							:gridName="gridNameTree"
							:dataPath="searchParam.modalData.selectFtnPlcListTree"
							:parentPrgmId="parentPrgmId"
							@getRowsData="getRowData"
							@dblClick="setUpdate()"
						/>
					</div>
					<!-- <component
            :is="ftnPlcListTreeData.length > 0 ? 'Tree' : null"
            :tree-data="ftnPlcListTreeData"
          /> -->
				</v-card-text>
				<v-divider></v-divider>
				<v-card-actions>
					<v-spacer></v-spacer>
					<v-btn color="primary" dark @click="setUpdate()">확인</v-btn>
					<v-btn color="primary" dark @click="dialog = false">닫기</v-btn>
					<!-- <v-btn
            color="green darken-1"
            text
            @click="dialog = false"
          >
            Disagree
          </v-btn>
          <v-btn
            color="green darken-1"
            text
            @click="dialog = false"
          >
            Agree
          </v-btn> -->
				</v-card-actions>
			</v-card>
		</v-dialog>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import Grid from '~/components/common/Grid';
import Utility from '~/plugins/utility';

export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		label: {
			type: String,
			require: false,
			default: '공장/설비',
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
	},
	components: {
		Grid,
		// Tree
	},
	data() {
		return {
			// label: "공정/설비",
			labelPrepend: true,

			myModalKey: 'selectFtnPlcListTree',
			gridNameTree: 'treeGrid',
			loadGrid: false,

			dialog: false,
			treeData: [], // 리턴받은 원본 트리 데이터
			modalDataKey: 'modalData',
			treeExpandAll: true,
			activeRowData: {},
		};
	},
	computed: {
		...mapState({
			// searchParam: state => state.pageData,
			searchParam(state) {
				return state.pageData[this.parentPrgmId];
			},
		}),
		chkDialog() {
			// 모달 열기/닫기 값
			return this.dialog;
		},
		selectValue() {
			// 선택된 공장/설비 값
			const temp = [];
			const facData = this.searchParam.isMulti
				? this.searchParam.facInfoList
				: this.searchParam.facInfo;
			if (Array.isArray(facData)) {
				if (facData.length > 0) {
					for (const item of facData) {
						temp.push(item.readPlcNm);
					}
				}
			} else {
				return facData.readPlcNm;
			}
			return temp.join();
		},
		treeExpand() {
			return this.treeExpandAll ? '접기' : '펼치기';
		},
	},
	watch: {
		async chkDialog(val) {
			if (val) {
				await this.getTreeData();
			}
		},
	},

	beforeCreate() {
		this.$store.commit('setPageData', {
			modalData: { selectFtnPlcListTree },
		});
	},
	created() {
		this.init();
		// this.setPageData({
		//   facInfo : localStorage.getItem(this.parentPrgmId + "CheckedRow") !=null ? JSON.parse(localStorage.getItem(this.parentPrgmId + "CheckedRow")) : {}
		// });
	},
	methods: {
		...mapMutations({
			setPageData: 'setPageData',
			setModalGridData: 'setModalGridData',
			setModalGridColumn: 'setModalGridColumn',
			setModalGridOption: 'setModalGridOption',
		}),
		...mapActions({
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
		}),
		init() {
			// console.log("init 시작...");
			this.activeRowData = {};
			this.gridInit();
			// this.getTreeData();
			// this.lineCOption = chartOption;
		},
		// 공정/설비 트리 그리드 세팅
		gridInit() {
			// console.log("gridInit 시작...");
			const treeGridHeight = 490; // this.$refs.treeGridParent.offsetHeight - 30;
			const myOptionsTree = {
				treeColumnOptions: {
					name: 'readPlcNm',
					//useCascadingCheckbox: false
				},
			};
			if (this.searchParam.isMulti) {
				myOptionsTree['rowHeaders'] = [{ type: 'checkbox' }];
				myOptionsTree['rowHeight'] = 'auto'; // checkbox와 그리드 높이 같게
				myOptionsTree['treeColumnOptions']['useCascadingCheckbox'] = false;
			} else {
				delete this.$store.state.pageData[this.parentPrgmId]['modalData'][
					this.myModalKey
				].treeGrid.option.rowHeaders;
			}
			this.setModalGridOption({
				modalKey: this.myModalKey,
				gridKey: this.gridNameTree,
				modalDataKey: this.modalDataKey,
				// value: myOptionsTree
				value: Object.assign(
					Utility.defaultGridOption(treeGridHeight),
					myOptionsTree,
				),
			});

			this.setModalGridColumn({
				modalKey: this.myModalKey,
				gridKey: this.gridNameTree,
				modalDataKey: this.modalDataKey,
				value: [
					{
						header: '측정 개소명',
						name: 'readPlcNm',
						width: 370,
						align: 'left',
					},
					{ header: '측정 개소', name: 'name', align: 'center' },
				],
			});
		},
		// 공정/설비 조회
		async getTreeData() {
			// console.log("getTreeData 시작...");

			this.loadGrid = false;
			// console.log("getTreeData energyList : ", this.searchParam.energyList);
			// console.log("getTreeData energyCd : ", this.searchParam.energyCd);
			const res = await this.postApiReturn({
				apiKey: 'selectReadPlcTree',
				resKey: 'ftnPlcTreeData',
				sendParam: {
					blocId: this.searchParam.blocMstrList[this.searchParam.blocId].blocId, //"BL0001",
					// mttCd: this.searchParam.energyList[this.searchParam.energyCd].cd
					mttCd: this.searchParam.energyCd,
				},
			});
			// console.log("getTreeData : ", res);
			// this.treeData = res;
			// const ROOT = res[0].plcCd;
			const setTreeData = await this.setTree({
				gridKey: this.gridNameTree,
				treeKey: 'READ_PLC_ID',
				value: res.map(item => ({
					...item,
					rowStat: null,
					readPlcId: item.readPlcId,
					readPlcIdNm: item.readPlcNm,
					upReadPlcId:
						item.upReadPlcId == null || item.upReadPlcId == ''
							? ''
							: item.upReadPlcId,
				})),
			});

			this.treeData = setTreeData;

			this.setModalGridData({
				modalKey: this.myModalKey,
				gridKey: this.gridNameTree,
				modalDataKey: this.modalDataKey,
				value: setTreeData.ROOT,
			});
			this.loadGrid = true;

			this.$nextTick(() => {
				if (this.searchParam.isMulti) {
					this.setGridCheckedRows();
				}
			});
		},
		// 공정/설비 트리 row 클릭이벤트
		async getRowData(data) {
			// console.log("getRowData 시작...");
			this.activeRowData = data;
		},
		setUpdate() {
			// console.log("setUpdate 시작...");
			if (this.activeRowData) {
				this.dialog = false;
				this.setPageData({ facInfo: this.activeRowData });
				localStorage.setItem(
					this.parentPrgmId + 'CheckedRow',
					JSON.stringify(this.searchParam.facInfo),
				);
			}
		},
		// 공정/설비 트리 접기/펼치기
		btnTreeExpand() {
			// console.log("btnTreeExpand 시작...");
			this.treeExpandAll = !this.treeExpandAll;
			if (this.treeExpandAll)
				this.$refs['treeGrid' + this.parentPrgmId].expandAll();
			else this.$refs['treeGrid' + this.parentPrgmId].collapseAll();
		},
	},
};

const selectFtnPlcListTree = {
	treeGrid: {
		data: [],
		column: [], // myColumns,
		option: {}, // myOptions
	},
	eqpmYn: 1,
};
</script>

<style scoped>
.v-input {
	font-size: 12px;
}
.v-label {
	font-size: 10px;
}
</style>
